#include "airdevicewindow.h"
#include "airOperations.h"
#include "ui_airdevice.h"

AirDeviceWindow::AirDeviceWindow(QWidget *parent) :
   QMainWindow(parent),
   ui(new Ui::AirDevice),
   airDevice(DEVICE_TYPE, DEVICE_FRIENDLY_NAME,
                  DEVICE_MANUFACTURER, DEVICE_MANUFACTURER_URL,
                  DEVICE_MODEL_DESCRIPTION, DEVICE_MODEL_NAME, 
                  DEVICE_MODEL_NUMBER, DEVICE_MODEL_URL,
                  DEVICE_SERIAL_NUMBER, getCompleteUuid())
{
   this->ui->setupUi(this);
   AirService* airService = new AirService();
   airService->setDescriptionFile("airServiceAction.xml");
   this->airDevice.addService(airService);
   this->airDevice.start();
   this->temperature = this->airDevice.getServiceByType(SERVICE_TYPE)->getVariable("Temperature");
   this->status = this->airDevice.getServiceByType(SERVICE_TYPE)->getVariable("Status");
   connect(this->status,
      SIGNAL(changed(BrisaStateVariable*)),
      this,
      SLOT(changeStatus(BrisaStateVariable*)));
   connect(this->temperature,
      SIGNAL(changed(BrisaStateVariable*)),
      this,
      SLOT(changeTemperature(BrisaStateVariable*)));
       this->ui->txt_tempDisplay->display(temp->getValue().toInt());
}

void AirDeviceWindow::changeStatus(BrisaStateVariable* status) {
   if (status->getValue().toBool()) {
      this->ui->bt_powerStatus->setPixmap(QPixmap(":/figs/green.png"));
   } else {
      this->ui->bt_powerStatus->setPixmap(QPixmap(":/figs/red.png"));
      }
}

void AirDeviceWindow::changeTemperature(BrisaStateVariable* temperature) {
   this->ui->txt_tempDisplay->display(temperature->getValue().toInt());
}

AirDeviceWindow::~AirDeviceWindow() {
   delete this->ui;
}

void AirDeviceWindow::changeEvent(QEvent *event) {
   QMainWindow::changeEvent(event);
   switch (event->type()) {
      case QEvent::LanguageChange:
         this->ui->retranslateUi(this);
                break;
      default:
           break;
   }
}
